Overview | Package | Class | Deprecated | Index | Help
| Groovy 1.7.6
| FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## groovy.util
[Java] Class XmlSlurper

    java.lang.Object
      org.xml.sax.helpers.DefaultHandler
          groovy.util.XmlSlurper

    public class XmlSlurper
    extends DefaultHandler

Parse XML into a document tree that may be traversed similar to XPath expressions. For example:

     def rootNode = new XmlSlurper().parseText(
        '<root><one a1="uno!"/><two>Some text!</two></root>' )

     assert rootNode.name() == 'root'
     assert rootNode.one[0].@a1 == 'uno!'
     assert rootNode.two.text() == 'Some text!'
     rootNode.children().each { assert it.name() in ['one','two'] }

Note that in some cases, a 'selector' expression may not resolve to a single node. For example:

     def rootNode = new XmlSlurper().parseText(
        '''<root>
             <a>one!</a>
             <a>two!</a>
           </root>''' )

     assert rootNode.a.size() == 2
     rootNode.a.each { assert it.text() in ['one!','two!'] }

Authors:
  John Wilson

See Also:
  GPathResult

Constructor Summary
`XmlSlurper()` Uses the defaults of not validating and namespace aware.
`XmlSlurper(boolean validating, boolean namespaceAware)`
`XmlSlurper(XMLReader reader)`
`XmlSlurper(SAXParser parser)`

Method Summary
`void` | `characters(char[] ch, int start, int length)`
`void` | `endDocument()`
`void` | `endElement(String namespaceURI, String localName, String qName)`
`DTDHandler` | `getDTDHandler()`
`GPathResult` | `getDocument()` @return The GPathResult instance created by consuming a stream of SAX events Note if one of the parse methods has been called then this returns null Note if this is called more than once all calls after the first will return null
`EntityResolver` | `getEntityResolver()`
`ErrorHandler` | `getErrorHandler()`
`boolean` | `getFeature(String uri)`
`Object` | `getProperty(String uri)`
`GPathResult` | `parse(InputSource input)` Parse the content of the specified input source into a GPathResult object
`GPathResult` | `parse(File file)` Parses the content of the given file as XML turning it into a GPathResult object
`GPathResult` | `parse(InputStream input)` Parse the content of the specified input stream into an GPathResult Object.
`GPathResult` | `parse(Reader in)` Parse the content of the specified reader into a GPathResult Object.
`GPathResult` | `parse(String uri)` Parse the content of the specified URI into a GPathResult Object
`GPathResult` | `parseText(String text)` A helper method to parse the given text as XML
`void` | `setDTDHandler(DTDHandler dtdHandler)`
`void` | `setEntityBaseUrl(URL base)` Resolves entities against using the suppied URL as the base for relative URLs
`void` | `setEntityResolver(EntityResolver entityResolver)`
`void` | `setErrorHandler(ErrorHandler errorHandler)`
`void` | `setFeature(String uri, boolean value)`
`void` | `setKeepWhitespace(boolean keepWhitespace)` @param keepWhitespace
`void` | `setProperty(String uri, Object value)`
`void` | `startDocument()`
`void` | `startElement(String namespaceURI, String localName, String qName, Attributes atts)`
`void` | `startPrefixMapping(String tag, String uri)`

Methods inherited from class DefaultHandler
error, warning, setDocumentLocator, startDocument, endDocument, startPrefixMapping, endPrefixMapping, startElement, endElement, characters, ignorableWhitespace, processingInstruction, skippedEntity, resolveEntity, fatalError, notationDecl, unparsedEntityDecl, wait, wait, wait, equals, toString, hashCode, getClass, notify, notifyAll

Methods inherited from class Object
wait, wait, wait, equals, toString, hashCode, getClass, notify, notifyAll

Constructor Detail

### XmlSlurper

    public XmlSlurper()

  Uses the defaults of not validating and namespace aware.
  throws:
    ParserConfigurationException
  throws:
    SAXException

### XmlSlurper

    public XmlSlurper(boolean validating, boolean namespaceAware)

### XmlSlurper

    public XmlSlurper(XMLReader reader)

### XmlSlurper

    public XmlSlurper(SAXParser parser)

Method Detail

### characters

    public void characters(char[] ch, int start, int length)

### endDocument

    public void endDocument()

### endElement

    public void endElement(String namespaceURI, String localName, String qName)

### getDTDHandler

    public DTDHandler getDTDHandler()

### getDocument

    public GPathResult getDocument()

  Returns:
    The GPathResult instance created by consuming a stream of SAX events Note if one of the parse methods has been called then this returns null Note if this is called more than once all calls after the first will return null

### getEntityResolver

    public EntityResolver getEntityResolver()

### getErrorHandler

    public ErrorHandler getErrorHandler()

### getFeature

    public boolean getFeature(String uri)

### getProperty

    public Object getProperty(String uri)

### parse

    public GPathResult parse(InputSource input)

  Parse the content of the specified input source into a GPathResult object
  throws:
    IOException
  throws:
    SAXException
  Parameters:
    input
  Returns:
    An object which supports GPath expressions

### parse

    public GPathResult parse(File file)

  Parses the content of the given file as XML turning it into a GPathResult object
  throws:
    IOException
  throws:
    SAXException
  Parameters:
    file
  Returns:
    An object which supports GPath expressions

### parse

    public GPathResult parse(InputStream input)

  Parse the content of the specified input stream into an GPathResult Object. Note that using this method will not provide the parser with any URI for which to find DTDs etc
  throws:
    IOException
  throws:
    SAXException
  Parameters:
    input
  Returns:
    An object which supports GPath expressions

### parse

    public GPathResult parse(Reader in)

  Parse the content of the specified reader into a GPathResult Object. Note that using this method will not provide the parser with any URI for which to find DTDs etc
  throws:
    IOException
  throws:
    SAXException
  Parameters:
    in
  Returns:
    An object which supports GPath expressions

### parse

    public GPathResult parse(String uri)

  Parse the content of the specified URI into a GPathResult Object
  throws:
    IOException
  throws:
    SAXException
  Parameters:
    uri
  Returns:
    An object which supports GPath expressions

### parseText

    public GPathResult parseText(String text)

  A helper method to parse the given text as XML
  Parameters:
    text
  Returns:
    An object which supports GPath expressions

### setDTDHandler

    public void setDTDHandler(DTDHandler dtdHandler)

### setEntityBaseUrl

    public void setEntityBaseUrl(URL base)

  Resolves entities against using the suppied URL as the base for relative URLs
  Parameters:
    `base` - The URL used to resolve relative URLs

### setEntityResolver

    public void setEntityResolver(EntityResolver entityResolver)

### setErrorHandler

    public void setErrorHandler(ErrorHandler errorHandler)

### setFeature

    public void setFeature(String uri, boolean value)

### setKeepWhitespace

    public void setKeepWhitespace(boolean keepWhitespace)

  Parameters:
    `keepWhitespace` - If true then whitespace before elements is kept. The default is to discard the whitespace.

### setProperty

    public void setProperty(String uri, Object value)

### startDocument

    public void startDocument()

### startElement

    public void startElement(String namespaceURI, String localName, String qName, Attributes atts)

### startPrefixMapping

    public void startPrefixMapping(String tag, String uri)

Copyright © 2003-2010 The Codehaus. All rights reserved.